filename = "timefile.txt"

function editLine(line)
    local timenow = os.time()
    _, _, starttime = string.find(line, "%w+, start (%d+)$")
    local duration = timenow - starttime
    print(string.format("Duration was %d minutes %d seconds", 
                        duration/60, duration % 60))
    return line .. string.format(", end %d, duration %d", timenow, duration) 
end

function writeWholeTimeFile(lines, linesRemain)
    local f = assert(io.open(filename, "w"))
    for i, line in ipairs(lines) do
        f:write(line, "\n")
    end
    if linesRemain then f:write(linesRemain) end
    f:close()
end

function recordStart(title)
    local timenow = os.time()
    local f = assert(io.open(filename, "a"))
    f:write(string.format("%s, start %d\n", title, timenow))
    f:close()
end

function recordEnd(title)
    local f = assert(io.open(filename, "r"))
    local lines = {}
    local linesRemain
    for line in f:lines() do
        if string.find(line, string.format("^%s", title)) then
            newLine = editLine(line)
            lines[#lines + 1] = newLine
            linesRemain = f:read("*a")
            break
        else
            lines[#lines + 1] = line
        end
    end
    f.close()
    writeWholeTimeFile(lines, linesRemain)
end

io.stdout:write("Type project name\n")
local project = io.stdin:read()
io.stdout:write("Type s to start timing, t to stop timing, or c to cancel\n")
local input = io.stdin:read()
if input == "s" then
    recordStart(project)
elseif input == "t" then
    recordEnd(project)
else
    error("cancelled project start")
end
