filename = "timefile.txt"
timetable = {}

function tableRecordStart(title)
    local timenow = os.time()
    table.insert(timetable, {project = title, starttime = timenow})
end

function tableRecordEnd(title)
    local timenow = os.time()
    for i, v in ipairs(timetable) do
        if v.project == title and tonumber(v.endtime) == 0 then
            d = timenow - v.starttime
            table.remove(timetable, i)
            table.insert(timetable, i, {project = v.project, 
                            starttime = v.starttime, 
                            endtime = timenow, 
                            duration = d})
        print(string.format("Duration was %d minutes %d seconds", 
              d/60, d % 60))
              break
        end
    end
end

function outputTableToScreen()
    print "Printing table"
    for i, v in ipairs(timetable) do 
        print(i, v.project, v.starttime, v.endtime, v.duration)
    end
end

function serialiseTable()
    local f = assert(io.open(filename, "w"))
    for i, v in ipairs(timetable) do 
        f:write(string.format(
            "readInTable{project = \"%s\", starttime = \"%d\", endtime = \"%d\", duration = \"%d\"}\n", 
            v.project, v.starttime, v.endtime or 0, v.duration or 0))
    end
    f:close()
end

function readInTable(o)
    table.insert(timetable, o)
end

dofile(filename)
outputTableToScreen()
io.stdout:write("Type project name\n")
local project = io.stdin:read()
io.stdout:write("Type s to start timing, t to stop timing, or c to cancel\n")
local input = io.stdin:read()
if input == "s" then
    tableRecordStart(project)
elseif input == "t" then
    tableRecordEnd(project)
else
    error("cancelled project start")
end
outputTableToScreen()
serialiseTable()
